
import 'package:flutter_vasat/models/vasat_model.dart';

class EventLog extends VasatModel<EventLog> {

  String? priority;
  String? value;
  int? eventDate;
  String? scope;
  Map<String,dynamic>? meta;
  String? ipAddress;
  String? client;
  String? device;
  String? user;

  EventLog({this.value, this.priority, this.device, this.user, this.client, this.eventDate, this.ipAddress, this.meta, this.scope});

  EventLog.fromJson(Map<String, dynamic> json) :
      priority = json["priority"],
      value = json['value'],
      eventDate = json["eventDate"],
      scope = json['scope'],
      ipAddress = json['ipAddress'],
      client = json["client"],
      device = json['device'],
      user = json['user'],
      meta = json['meta'];

  @override
  Map<String, dynamic> toJson() {
    var obj = <String, dynamic>{};
    obj["priority"] = priority;
    obj["value"] = value;
    obj["scope"] = eventDate;
    obj["scope"] = scope;
    obj["ipAddress"] = ipAddress;
    obj["client"] = client;
    obj["device"] = device;
    obj["user"] = user;
    obj["meta"] = meta;
    return obj;
  }

  @override
  fromJsonItem(Map<String, dynamic>? json) {
    // TODO: implement fromJsonItem
    throw UnimplementedError();
  }

  @override
  Map<String, dynamic> toJsonItem() {
    return toJson();
  }

}