abstract class VasatModel<T> {

  String? id;
  String? displayName;
  int? dateMade;
  int? dateUpdated;
  List<String>? acl;
  bool? dirty;

  VasatModel({Map<String, dynamic>? json, this.id, this.dirty}) {
    fromJson(json);
  }

  fromJson(Map<String, dynamic>? json) {
    if (json != null) {
      id = json['id'];
      displayName = json['displayName'];
      dateMade = json['dateMade'];
      dateUpdated = json['dateUpdated'];
      // Object specific fields. As Vasat allows for inline fields we simply check if we have the item field. If we do use it. Otherwise assume all object fields are inline
      fromJsonItem( (json['item'] != null) ? json['item'] : json);
    }
  }

  Map<String, dynamic> toJson() {
    return {
      "id": id,
      "displayName": displayName,
      "dateMade": dateMade,
      "dateUpdated": dateUpdated,
      "item": toJsonItem()
    };
  }

  Map<String, dynamic> toJsonItem();

  fromJsonItem(Map<String, dynamic>? json);

  String getObjectName() {
    return this.runtimeType.toString();
  }
}